package de.fraunhofer.iem.dataprovider.kpi.dto

import de.fraunhofer.iem.dataprovider.kpi.model.KPI
import de.fraunhofer.iem.dataprovider.kpi.strategy.KPICalculationStrategy
import java.sql.Timestamp
import java.time.Instant


class KPIDto(val name: String, val description: String, val isRoot: Boolean, private val calculationStrategy: KPICalculationStrategy) {
    val hierarchyEdges: MutableList<KPIHierarchyEdgeDto> = mutableListOf<KPIHierarchyEdgeDto>()
    var value: Int? = null

    fun calculateKPI() {
        this.value = calculationStrategy.calculateKPI(this.hierarchyEdges);
    }

    fun addChildKPI(kpiDto: KPIDto, weight: Double) {
        val hierarchyEdge = KPIHierarchyEdgeDto(this, kpiDto, weight)
        this.hierarchyEdges.add(hierarchyEdge)
    }

    fun toDbObject(): KPI {
        val kpi = KPI()
        kpi.name = this.name
        kpi.value = this.value
        kpi.description = this.description
        kpi.isRoot = this.isRoot
        kpi.timestamp = Timestamp.from(Instant.now())
        return kpi
    }
}